#include <stdio.h>
#include <string.h>

int main(int argc, char **argv)
{
	FILE *f;
	int len;
	int lendiff;

	if (argc != 3)
	{
		printf("Usage: %s [path to ezquake-security.so] [new check path]\n", argv[0]);
		printf("Warning: There will be no validation that the file given is the correct file\n");
		printf("         Supplying any other file than ezquake-security.so v1517 WILL trash it\n");

		return 0;
	}

	if ((len = strlen(argv[2])) != 12)
	{
		if (len < 14)
			lendiff = 12-len;
		else
			lendiff = len-12;

		printf("Your path is %d character%s too %s\n", lendiff, lendiff==1?"":"s", len<12?"short":"long");
		return 0;
	}

	f = fopen(argv[1], "r+");
	if (f)
	{
		if (fseek(f, 0x4b05, SEEK_SET) == 0)
		{
			if (fwrite(argv[2], 1, 12, f) == 12)
			{
				printf("Successfully updated file!\n");
			}
			else
				printf("Unable to write new path\n");
		}
		else
			printf("Unable to seek to the correct position in the file\n");

		fclose(f);
	}
	else
		printf("Unable to open \"%s\"\n", argv[1]);

	return 0;
}

